{ pkgs, ... }:
let
  emacs_pkg = ((pkgs.emacsPackagesFor pkgs.emacs30-pgtk).emacsWithPackages (
      epkgs: with epkgs; [
        vterm
        mu4e
        sly
        sly-quicklisp
        geiser-racket
        cider
        editorconfig
        shfmt
        apheleia
        parinfer-rust-mode
        tree-sitter-langs
        treesit-grammars.with-all-grammars
        pretty-sha-path
        pdf-tools
        org-pdftools
        nerd-icons
        nerd-icons-ibuffer
        tab-line-nerd-icons
        nerd-icons-dired
        nerd-icons-corfu
        nerd-icons-completion
        eldoc
        tablist
        parseedn
        parseclj
        track-changes
        pretty-sha-path
      ]));
in {
  programs.emacs = {
    enable = true;
    package = emacs_pkg;
  };

  services.emacs = {
    enable = true;
    defaultEditor = true;
    package = emacs_pkg;
    socketActivation.enable = true;
    client = {
      enable = true;
      arguments = ["-n" "-r"];
    };
  };

  xdg.configFile."emacs".enable = false;

}
